
#define     _CRT_SECURE_NO_WARNINGS
#include <stdio.h>
#include <string.h>

#define ANGEL		0
#define EVIL         1

char Roll[30], StoneBridge[2][120];
int DynamicTable[2][30], RollLength;

int SolveDT(int RollLength)
{
    for (int i = 0; StoneBridge[EVIL][i] != 0; i++) 
    {
        for (int j = RollLength - 1; j >= 0; j--) 
        {
            if (StoneBridge[ANGEL][i] == Roll[j])
                DynamicTable[EVIL][j + 1] += DynamicTable[ANGEL][j];

            if (StoneBridge[EVIL][i] == Roll[j])
                DynamicTable[ANGEL][j + 1] += DynamicTable[EVIL][j];
        }
    }

    return DynamicTable[ANGEL][RollLength] + DynamicTable[EVIL][RollLength];
}

int main(void)
{
    int result;

    strcpy(Roll, "RGS");
    strcpy(StoneBridge[ANGEL], "RINGSR");
    strcpy(StoneBridge[EVIL], "GRGGNS");

    RollLength = strlen(Roll);

    DynamicTable[ANGEL][0] = 1;
    DynamicTable[EVIL][0] = 1;

    result = SolveDT(RollLength);

    printf("%d\n", result);

    return 0;
}

